<template>
  <div class="hotel">
    <header class="hotel__header">
      <h1>
        <span class="hotel__keyword">HOTEL</span>
        <span class="hotel__name">{{ essentialData.name }}</span>
      </h1>
      <div v-if="essentialData.rating" class="hotel__rating">
        <span v-for="(star, i) in parseInt(essentialData.rating, 10)" :key="i">★</span>
      </div>
    </header>
    <section class="hotel__plan-choice">
      <plan v-for="plan in plans" :plan="plan" :key="plan.id" @choosePlan="commitPlan(plan.id)"></plan>
    </section>
  </div>
</template>

<script>
import Plan from '@/components/ChoosePlan/Plan.vue';

export default {
  name: 'choosePlan',
  components: {
    Plan,
  },
  computed: {
    essentialData() {
      return this.$store.getters.essentialData;
    },
    plans() {
      return this.$store.getters.plans;
    },
  },
  methods: {
    commitPlan(planID) {
      // Here, we'd commit the first part of the checkout options to the store and continue
      // with the checkout process
      // But instead, as an example, we are going to do a POST API request already
      this.$store.dispatch('checkoutPlan', planID);
      setTimeout(() => {
        // Next, the user is redirected to the second part of the checkout options
        this.$router.push({ name: 'chooseExtras' });
      }, 600);
    },
  },
};
</script>

<style lang="scss" scoped>
.hotel {
  background-color: $background-light;
  box-shadow: $primary-box-shadow;
}

.hotel__header {
  @extend %flex-center;
  padding: 30px;
  color: $primary-dark;
  font-size: 1.5rem;
}

.hotel__keyword {
  @include font-roboto-slab();
  margin-right: 0.3em;
}

.hotel__name {
  @include font-roboto-slab-bold();
}

.hotel__rating {
  position: relative;
  top: 1px;
  margin-left: 20px;
  color: gold;
  font-size: 0.8em;
}

.hotel__plan-choice {
  display: flex;
  flex-wrap: wrap;
  padding: 0 10px 25px;
}
</style>
